﻿using System.IO;
using System.Windows;
using ThinkGeo.Core;

namespace Shapefiles_sample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        LayerOverlay lo;
        ShapeFileFeatureLayer l;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void mapView_Loaded(object sender, RoutedEventArgs e)
        {
            mapView.MapUnit = GeographyUnit.Meter;

            l = new ShapeFileFeatureLayer(@".\data\original-shapefile\lines.shp");
            //l.RequireIndex = false;
            l.FeatureSource.ProjectionConverter = new ProjectionConverter(4326, 3857);
            l.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyle.CreateSimpleLineStyle(GeoColor.GetRandomGeoColor(RandomColorType.Bright), 2, false);
            l.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            lo = new LayerOverlay();
            lo.Layers.Add(l);
            mapView.Overlays.Add(lo);

            l.Open();
            mapView.CurrentExtent = l.GetBoundingBox();
            mapView.Refresh();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var files = new string[] { @".\data\simplified-shapefile\lines.shp", @".\data\simplified-shapefile\lines.shx", @".\data\simplified-shapefile\lines.prj", @".\data\simplified-shapefile\lines.idx", @".\data\simplified-shapefile\lines.ids", @".\data\simplified-shapefile\lines.dbf" };
            foreach (var filePath in files)
            {
                FileInfo sourcefile = new FileInfo(filePath);
                sourcefile.CopyTo(filePath.Replace("simplified", "original"), true);
            }
            // need to close and open shapefile after updaing the shapefile
            l.Close();
            l.Open();
            lo.Refresh();
        }
    }
}
